function [lprob] = eval_gmm_verify_diag_var(testdata, model);

if(isfield(model, 'means'))
    m = model.means;
    c = model.vars;
    prior = model.prob;
else
    m = model.mean';
    c = model.cov;
    prior = model.prior;
end
Nmix = size(c, 3);

for j=1:Nmix
    prob(j,:)  = prior(j) * gauss_dist(testdata, m(:,j), c(:,j));
end

% Obtain the probability of each observation.
prob = sum(prob,1);

% Removing frames with zero probability.
prob(prob == 0) = [];

% If prob is empty, then asssign largest negative value
if(isempty(prob))
	lprob = -inf;
	return;
end

lprob = log(prob);
lprob = sum(lprob)/length(lprob);
