function [nData, level, onesL] = filter_data(Data, rev, silnmix, silmethod);

% why 5 in smooth.
if(silnmix == 1)
    nData = Data;
    level = min(Data(1,:));
    return;
end

Ngau = silnmix;

pair = [1 2];

% Discard some begin and end frames if no. of frames to be discarded (here 20 (10+10)) is less than
% 10 percentage of size of data.
% discardN = 20;
discardN = 15;  % 8/31/07
if(discardN < size(Data,2)/20) % changed 10 to 20; 8/21/07
    Data = Data(:, discardN+1:end-discardN);
end

data = Data(1,:);
data = filter(ones(5,1), 1, data);

% length of data is less than No. of gaussians so just dont do anything.
if(length(data)/5 < Ngau)
    nData = Data;
    id = 1:size(Data,2);
    level = min(Data(1,:));
    onesL = [1:size(Data,2)];
    return;
end

% This is not very deterministic.
myem = mix_gau_N_diag_var(data, Ngau);
mean = myem.means; cov  = myem.vars; prob = myem.prob;
[jnk, id] = sort(mean,'ascend');
mean = mean(id);  prob = prob(id);
% Earlier had sorted mean but did not sort covariance accordingly. Need to
% sort cov too.
cov = cov(:,:,id);
cov = reshape(cov, 1, length(mean));

[level, Z] = get_level(mean, cov, prob, silmethod, pair);

needplot = 0;
datax = [mean(1) - 3*sqrt(cov(1)) : sqrt(cov(1))/10 : mean(end) + 3*sqrt(cov(end))];

if needplot
    colors = {'r','b','m','g','r'};
    subplot(2,1,1); plot(data); hold on;
    plot([1:length(data)], level * ones(1,length(data)),'color','k');
    if(exist('level1'))
        % plot([1:length(data)], level1 * ones(1,length(data)),'k--');
    end

    subplot(2,1,2); [hm,hn] = hist(data, 50); diffhn = hn(2)-hn(1);
    hm = hm/sum(hm)/diffhn;
    plot(hn, hm, 'k'); hold on;
    dataally = [];
    for i = 1:length(mean)
        if(i>length(colors))
            colors{i} = 'r';
        end
        %subplot(2,1,1); plot([1:length(data)], mean(i) * ones(1,length(data)),'color',colors{i});
        % datax = [mean(i) - 2*sqrt(cov(i)) : sqrt(cov(i))/10 : mean(i) +
        % 2*sqrt(cov(i))];
        % dcov = sprintf('covariancei = %f', cov(i)); display(dcov);
        datay = prob(i) * 1/sqrt(2*pi*cov(i)) * exp(-(datax - mean(i)).^2/2/cov(i));
        subplot(2,1,2); plot(datax, datay, 'color',colors{i});
        %subplot(2,1,2); plot(datax, datay/prob(i), 'color',colors{i}, 'LineStyle', '--');
        dataally(i,:) = datay;
    end
    subplot(2,1,2); plot(level, [0:max(hm)/20:max(hm)], '.-');
    if(exist('level1'))
        % subplot(2,1,2); plot(level1, [0:max(hm)/20:max(hm)/2], 'k--');
    end
    subplot(2,1,2); plot(datax, sum(dataally,1), 'k-');
    subplot(2,1,2); plot(datax, sum(dataally(2:end,:),1), 'b-');
    subplot(2,1,2); ylim([0 max(max(max(dataally(:)), max(hm)))]);
    hold off;
    hold off;
end

ncols = obtain_thresh(data, level);
[onesL, zerosL] = findones_zeros(ncols);
% Hashed id but this id is being used at somepoint later, and there was id
% defined in workspace which got used actually..
[jnk, id] = find(ncols==1);

if(~isempty(id))
    nData = Data(:,id);
    if needplot
        subplot(2,1,1); hold on;
        for i = 1:size(onesL,1)
            %thisdata = min(data) * ones(1,length(data));
            %thisdata = level * ones(1,length(data));
            %thisdata(id) = data(id);
            plotid = [onesL(i,1):onesL(i,2)];
            plot(plotid, data(plotid),'r.-');
        end
        hold off;
        pause;
    end
else
    nData = Data;
    disp('Found empty ncols');
end

function [ndata] = obtain_thresh(data, level);
ndata = zeros(size(data));
ndata(data>=level) = 1;
