function y = gauss_dist(x, m, v);

global var_floor;
if(isempty(var_floor))
    var_floor = 1e-4;
end

[Ndim, Nobs] = size(x);
m = myrepmat(m, 1, Nobs);
x_m = x-m;

if(isvector(v))
    v(v<var_floor) = var_floor;
    temp_mult = myrepmat((1./v), 1, Nobs) .* x_m; 
    det_v = prod(v); 
else   
    inv_v = pinv(v);
    temp_mult = inv_v * x_m; 
    det_v = (1/det(inv_v));
end
mahal_x   = sum(x_m .* temp_mult, 1);

% Not using the normalization factor in pi.
y = exp(-mahal_x/2)/sqrt(det_v);

function [B] = myrepmat(A, M, N); 
% just to handle the myrepmat in this function.
% A very specific myrepmat, just for this particular case.
B = A(:, ones(N, 1));




