function [] = generate_loadfile_test;

% Test features are generated and they will be saved at /Data/test_feats.mat

rem_sil = 1;
frame_rate = 100;

global mypath;
global myfeatspath;

[Sp us ue Spid] = textread(strcat(mypath, 'Sessions/test.lst'),'%s %f %f %s');

cSp = '';  % Current Speaker
spid = 0;                  spid_cnt = 0;
rev = 0;
data_test = {};
Speakers = {};

for cnt = 1:length(Sp);
    [fname, fext] = strread(Sp{cnt}, '%s%s', 'delimiter', '/');
    if(~strcmp(fname{1}, cSp))
        spid = spid + 1;
        Speakers{spid} = fname{1};
        cSp = fname{1};
        % spid serves as indicator for cSp (current speaker)
        spid_cnt = 0;
    end

    myRpath = strcat(myfeatspath, 'Test/', Sp{cnt});

    if(~exist(myRpath))
        err_str = sprintf('%s does not exist', myRpath);
        error(err_str);
    end

    data = readmfcc(myRpath);
    % Convert time in seconds to time in frame no.
    sfid = max(1, 1+floor(us(cnt) * frame_rate));
    efid = min(ceil(ue(cnt) * frame_rate), size(data, 2));
    efid = max(1, efid);

    if(sfid > efid)
        Speakers{end}
        [sfid, efid]
        error(sprintf('For %s, starts at %d, ends at %d, thus ends earlier than beginning',Speakers{end}, sfid, efid));
    elseif(sfid == efid)
        data = data(:, sfid);
        disp('For %s, starts at %d, ends at %d, thus ends same as beginning',Speakers{end}, sfid, efid);
    else
        data = data(:, sfid:efid);
        % data = filter_data(data, rev);
    end
    data_test{1+length(data_test)} = data;

    mycnt = min(length(Sp), cnt+1);
    [fname1, fext1] = strread(Spid{cnt}, '%s%s', 'delimiter', '-');
    [fname2, fext2] = strread(Spid{mycnt}, '%s%s', 'delimiter', '-');

    if((~strcmp(fext2{1}, fext1{1}) | ~strcmp(fname1{1}, fname2{1})) | cnt == length(Sp))
        spid_cnt = spid_cnt + 1;
        Feat{spid}{spid_cnt} = data_test;
        data_test = {};
    end
end

savefilen = strcat(mypath, 'Data/test_feats');
TestFeat = Feat; clear Feat;
save(savefilen, 'TestFeat', 'Speakers');