function [] = generate_loadfile_train_simple(Ntrain)

% 2/14/07 : Obtained from generate_loadfile_train, to use the simple format
% of train.lst and test.lst

% readmfcc
% filter_data

% Train features are generated and they will be saved at /Data/train_feats.mat

%%% Start Initial definitions %%%
global myDatapath myTrainfeatspath trainlabel trainlist trainfiles;

%% Parameters for filter_data
Ngau_sil = 4; silmethod = 2;
rev = 0;     % A redundant parameter for now
%%% End Initial definitions %%%

savefilen = trainfiles; 
if(exist(savefilen, 'file'))
    disp(strcat(savefilen, 'exists..quiting'));
    return;
end

%% Read the trainlist
[Sp] = textread(trainlist, '%s');

tsp = ''; spid_cnt = 0;
%%% Start building train files %%%
for spid = 1:length(Sp)
    csp = strread(Sp{spid}, '%s', 'delimiter', '/'); csp = csp{1};
    if(~strcmp(csp, tsp))
        spid_cnt  =  spid_cnt + 1;
        tsp = csp;
        Feat{spid_cnt} = {};
    end
    % Create myRpath for reading mfcc files.
    myRpath = strcat(myTrainfeatspath, Sp{spid});

    %%% If MFCC file does not exist then print error message.
    if(~exist(myRpath))
        err_str = sprintf('%s does not exist', myRpath);
        error(err_str);
    end
    
    % Read mfcc file
    data = readmfcc(myRpath);
    
    % This removes silence segments
    data = filter_data(data, rev,  Ngau_sil, silmethod);
    
    Feat{spid_cnt}{1+length(Feat{spid_cnt})} = data;
end

% Save operation.
TrainFeat = Feat; clear Feat;
save(savefilen, 'TrainFeat');