function [] = get_gmm_model(Nmix);

% Loads files /Data/train_feats.mat, so that must exist.

% Generates the individual GMM models for features in Feat.
% Nmix is number of GMM mixtures

% Dependencies :
% mix_gau_N_diag_var
% extract_model_2

% 2/19/08 : Added mean_norm for training features
% 2/19/08 : Removed c0 for training features

global mypath myDatapath;
global trainlabel trainmodel;

% Create directory
features = strcat(myDatapath, 'train_feats', trainlabel);
load(features);

models = strcat(myDatapath, trainmodel, '.mat');
if(exist(models, 'file'))
    disp([models '..exists..quitting']);
    return;
end
[Itrain] = build_model(TrainFeat, Nmix);
save(models, 'Itrain');

function [Itrain] = build_model(Feat, Nmix, mycase)
Itrain = {};
Ffeat = {};
global var_floor;
var_floor = 1e-4;

for sp = 1:length(Feat)
    feat = cell2mat(Feat{sp});    
    feat = mean_norm(feat);
    feat = feat(2:end, :);

    %%%% Individual Model %%%%
    Imodel = {}; logL = [];
    Nemcnt = 3;

    for emcnt = 1:Nemcnt
        [Imodel{emcnt}, logL(emcnt)]  = mix_gau_N_diag_var(feat, Nmix);
    end    
    [logl, id] = max(logL);
    Itrain{sp} = extract_model_2(Imodel{id});
    %%%% Individual Model %%%%
end