function [level, needplot] = get_level(mean, cov, prob, method, pair);
needplot = 0;
if(length(mean) < 2)
    error('length of mean should be atleast 2');
end

if(mean(1) > mean(2))
error('mean1 > mean2 : Reorder');
end

p1 = pair(1); p2 = pair(2);

Mean = [mean(p1); mean(p2)];
Prob = [prob(p1); prob(p2)];
Cov = [cov(p1); cov(p2)];
MC = [Mean, Cov, Prob];

% Starting point
x0 = (mean(p1)/cov(p1) + mean(p2)/cov(p2))/(1/cov(p1) + 1/cov(p2));

MC = [mean(:), cov(:), prob(:)];

options = optimset('TolFun', 5* 1e-3);
if(sign(myfun(mean(p1), MC, method)) ~= sign(myfun(mean(p2), MC, method)))
    level = fzero(@(x) myfun(x, MC, method), Mean, options);
else
    level = fzero(@(x) myfun(x, MC, method), x0, options);
    % If level is greater than mean(1) then it becomes level else it is
    % mean(1) + difference of level and mean(1)..not bad approximation.
    level = mean(1) + abs(mean(p1) - level);
    needplot = 0;
end
[mean(p1), mean(p2), cov(p1), cov(p2), x0, level];

function f = myfun(x, MC, method)
% x is a column vector.
% MC is [mean, cov, prob] with N * 3 dimensions.
f = 0;
if(method == 2)
    for i = 1:size(MC, 1)
        f = f + MC(i,3) * exp(-1/2 * (x-MC(i,1))' * inv(MC(i,2)) * (x-MC(i,1)))/sqrt(MC(i,2));
        if(i==1)
            % inverse
            f = -f;
        end
    end
elseif(method ==1)
    % Once 1/2 factor was missing here.
    error('Not to be used');
    f = (x-MC(1,1))' * inv(MC(1,2))/2 * (x-MC(1,1)) - (x-MC(2,1))' * inv(MC(2,2))/2 * (x-MC(2,1)) + 1/2 * log(det(MC(1,2))/det(MC(2,2)));
end