function [Err] = gmm_identification

% Error saved to 'Err_Nmix_<nmix>' file.
% 2/19/08 : Added mean_norm for testing features
% 2/19/08 : Added tempfeat variable, else was overwriting TestFeat which
% was needed at later stage

global mypath trainlabel testlabel trainmodel Nmix;

%% Load Models
models = strcat(mypath, 'Data/', trainmodel);
load(models);

%% Load testing features
testfeats = strcat(mypath, 'Data/test_feats', testlabel);
load(testfeats);

%% File to save errors/accuracy
err_case = strcat('Err_nmix_', num2str(Nmix), testlabel);

err = [];
%%% Load a Testfile, it is in format {Spid}{Trial}{decomposition}
for testi = 1:length(TestFeat)
    Nfiles = length(TestFeat{testi});
    for spfile = 1:Nfiles
        % Composing the components into one.
        gmmscore = [];
        for traini = 1:length(TestFeat)
            %% Cepstral Mean Normalize
            tempfeat = mean_norm(TestFeat{testi}{spfile});
            %% Remove C0
            tempfeat = tempfeat(2:end, :);
            logscores = eval_gmm_verify_diag_var(tempfeat, Itrain{traini});
            gmmscore = [gmmscore, logscores];
        end        
        [val, id] = max(gmmscore, [], 2);
        err = [err, (id ~= testi)];
    end
end
Err = mean(err, 2);
fprintf('For Nmix - %d, Identification Error = %.4f\n',Nmix, Err);
save(err_case, 'Err');